#include <iostream>
#include "neuron.h"

using namespace std;

Connection::Connection(Neuron *n, float weight) {
	neuron = n;
	this->weight = weight;
}


Neuron::Neuron() {
	threshold = 0.0;
	acc = 0.0;
	bias = 0.0;

	set_output(0.0, 1.0);
}

Neuron::~Neuron() {}

void Neuron::set_threshold(float t) {
	threshold = t;
}

void Neuron::set_bias(float b) {
	bias = b;
}

void Neuron::set_output(float inh, float exh) {
	fire_values[0] = inh;
	fire_values[1] = exh;
}

void Neuron::add_connection(Neuron *n, float weight) {
	con.push_back(Connection(n, weight));
}

void Neuron::input(float val) {
	acc += val;
}

float Neuron::fire() {
	float val = fire_values[acc + bias > threshold ? 1 : 0];
	for(int i=0; i<(int)con.size(); i++) {
		con[i].neuron->input(val * con[i].weight);
	}
	acc = 0.0;

	return val;
}


InputNeuron::InputNeuron(float val) {
	acc = val;
}

InputNeuron::~InputNeuron() {}

void InputNeuron::input(float val) {
	acc = val;
}

float InputNeuron::fire() {
	for(int i=0; i<(int)con.size(); i++) {
		con[i].neuron->input(acc * con[i].weight);
	}
	return acc;
}
