#ifndef _NEURON_H_
#define _NEURON_H_

#include <vector>

class Neuron;

struct Connection {
	float weight;
	Neuron *neuron;

	Connection(Neuron *n, float weight = 1.0);
};

class Neuron {
protected:
	float threshold;
	float acc;
	float bias;
	std::vector<Connection> con;

	float fire_values[2];

public:
	Neuron();
	virtual ~Neuron();

	virtual void set_threshold(float t);
	virtual void set_bias(float b);
	virtual void set_output(float inh, float exh);

	virtual void add_connection(Neuron *n, float weight = 1.0);

	virtual void input(float val);
	virtual float fire();
};

class InputNeuron : public Neuron {
public:
	InputNeuron(float val = 0.0);
	virtual ~InputNeuron();

	virtual void input(float val);
	virtual float fire();
};
	

#endif	// _NEURON_H_
